import { computed as k, ref as d, onMounted as Je, onBeforeUnmount as Ke, watch as Oe, openBlock as o, createElementBlock as n, normalizeClass as ie, normalizeStyle as Y, renderSlot as _, createBlock as H, createCommentVNode as v, unref as s, createSlots as Qe, withCtx as S, normalizeProps as Q, guardReactiveProps as Z, createVNode as Ie, createElementVNode as h, Fragment as m, renderList as I, toDisplayString as x, createTextVNode as De, nextTick as Ze, pushScopeId as et, popScopeId as tt } from "vue";
import { u as lt, o as at, e as Ae, g as ot, c as ut, b as st, d as Be, p as V, m as nt, G as rt, f as L, X as it, s as ee, w as vt, j as ct, H as F, i as X, k as b, n as te, t as dt, a as ht, x as yt, q as ft, r as pt } from "./index-DDXisDKy.js";
import { t as gt, u as bt } from "./useResponsive-NZB-WLRF.js";
import { _ as mt } from "./Title-DYNLqCCT.js";
import { u as wt, U as kt } from "./usePrinter-8ofTb2MJ.js";
import { D as _t } from "./DataTable-DL2agEJ3.js";
import { _ as xt } from "./Tooltip-CICAYyQj.js";
import { L as Ct } from "./Legend-DXLiSLHd.js";
import $t from "./vue-ui-skeleton-B2sRnIXX.js";
import Pt from "./vue-ui-accordion-D_1fE5EF.js";
import { u as Me } from "./useNestedProp-S1UXxUgm.js";
import { _ as St } from "./PackageVersion-DtnhR89q.js";
import { _ as Lt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ft = (R) => (et("data-v-159f668e"), R = R(), tt(), R), zt = ["id"], Tt = ["xmlns", "viewBox"], Yt = { key: 0 }, Xt = ["id"], Nt = ["stop-color"], Ot = ["offset", "stop-color"], It = ["offset", "stop-color"], Dt = ["stop-color"], At = { key: 1 }, Bt = ["id", "cx", "cy"], Mt = ["stop-color", "stop-opacity"], Gt = ["stop-color"], Vt = ["id"], jt = ["id"], Ht = /* @__PURE__ */ Ft(() => /* @__PURE__ */ h("feColorMatrix", {
  type: "saturate",
  values: "0"
}, null, -1)), Rt = ["id"], Ut = ["flood-color"], Et = ["id"], Wt = ["flood-color"], qt = ["d", "stroke", "filter"], Jt = ["x1", "y1", "x2", "y2", "stroke", "filter"], Kt = ["cx", "cy", "r", "fill", "filter"], Qt = ["stroke", "d"], Zt = ["d", "fill", "stroke", "stroke-width", "filter"], el = { key: 0 }, tl = ["stroke", "d"], ll = { key: 0 }, al = ["d", "stroke", "stroke-width", "filter"], ol = ["d", "fill", "stroke", "stroke-width", "filter"], ul = { key: 1 }, sl = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], nl = ["cx", "cy", "r", "stroke"], rl = ["cx", "cy", "r", "fill"], il = { key: 0 }, vl = ["d", "fill", "onMouseenter", "onClick"], cl = { key: 1 }, dl = ["cx", "cy", "r", "fill"], hl = ["x", "y", "fill", "font-size"], yl = ["x", "y", "fill", "font-size"], fl = ["x", "y", "fill", "font-size"], pl = ["x", "y", "fill", "font-size"], gl = ["filter"], bl = { key: 0 }, ml = ["x", "y"], wl = { key: 1 }, kl = ["cx", "cy", "fill", "stroke", "filter", "onClick"], _l = ["cx", "cy", "fill", "stroke", "filter", "onClick"], xl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], Cl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], $l = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], Pl = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], Sl = { key: 2 }, Ll = ["x", "y", "width"], Fl = ["x", "y", "width"], zl = {
  key: 3,
  class: "vue-data-ui-watermark"
}, Tl = ["onClick"], Yl = {
  key: 0,
  style: { "font-variant-numeric": "tabular-nums" }
}, Xl = { key: 1 }, Nl = ["innerHTML"], Ol = {
  __name: "vue-ui-donut",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(R, { expose: Ge, emit: ve }) {
    const N = R, { vue_ui_donut: Ve } = lt(), U = k({
      get() {
        return !!N.dataset && N.dataset.length;
      },
      set(l) {
        return l;
      }
    }), E = d(null), ce = d(null), de = d(null), le = d(null), he = d(0), ye = d(0), fe = d(0);
    Je(() => {
      pe();
    }), Ke(() => {
      le.value && le.value.disconnect();
    });
    function pe() {
      if (at(N.dataset) ? Ae({
        componentName: "VueUiDonut",
        type: "dataset"
      }) : N.dataset.forEach((l, r) => {
        ot({
          datasetObject: l,
          requiredAttributes: ["name", "values"]
        }).forEach((t) => {
          U.value = !1, Ae({
            componentName: "VueUiDonut",
            type: "datasetSerieAttribute",
            property: t,
            index: r
          });
        });
      }), e.value.responsive) {
        const l = gt(() => {
          const { width: r, height: t } = bt({
            chart: E.value,
            title: e.value.style.chart.title.text ? ce.value : null,
            legend: e.value.style.chart.legend.show ? de.value : null
          });
          u.value.width = r, u.value.height = t;
        });
        le.value = new ResizeObserver(l), le.value.observe(E.value.parentNode);
      }
    }
    const w = d(ut()), je = d(null), ae = d(!1), ue = d(""), P = d(null), ge = d(0);
    function be() {
      const l = Me({
        userConfig: N.config,
        defaultConfig: Ve
      });
      return l.theme ? {
        ...Me({
          userConfig: dt.vue_ui_donut[l.theme] || N.config,
          defaultConfig: l
        }),
        customPalette: ht[l.theme] || V
      } : l;
    }
    const e = k({
      get: () => be(),
      set: (l) => l
    });
    Oe(() => N.config, (l) => {
      e.value = be(), pe(), he.value += 1, ye.value += 1, fe.value += 1;
    }, { deep: !0 });
    const { isPrinting: me, isImaging: we, generatePdf: ke, generateImage: _e } = wt({
      elementId: `donut__${w.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-donut"
    }), xe = k(() => st(e.value.customPalette)), y = d({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), u = d({
      height: 360,
      width: 512
    }), W = k(() => {
      const l = e.value.style.chart.layout.donut.strokeWidth / 512, r = u.value.width * l, t = r > C.value ? C.value : r;
      return t < 24 ? 24 : t;
    }), M = k(() => N.dataset.map((l, r) => ({
      name: l.name,
      color: Be(l.color) || xe.value[r] || V[r] || V[r % V.length],
      value: l.values.reduce((t, a) => t + a, 0),
      absoluteValues: l.values,
      comment: l.comment || ""
    }))), z = d(M.value);
    Oe(() => M.value, (l) => z.value = l);
    function He() {
      return M.value.map((l) => ({
        name: l.name,
        color: l.color,
        value: l.value
      }));
    }
    const O = d([]), Ce = d(null), $e = d(null), G = d(!1);
    function Pe(l) {
      const r = M.value.find((i, g) => g === l);
      let a = z.value.find((i, g) => g === l).value;
      if (O.value.includes(l)) {
        let g = function() {
          a > i ? (cancelAnimationFrame(Ce.value), z.value = z.value.map((p, re) => l === re ? {
            ...p,
            value: i
          } : p), G.value = !1) : (G.value = !0, a += i * 0.025, z.value = z.value.map((p, re) => l === re ? {
            ...p,
            value: a
          } : p), Ce.value = requestAnimationFrame(g));
        };
        O.value = O.value.filter((p) => p !== l);
        const i = r.value;
        g();
      } else if (O.value.length < M.value.length - 1) {
        let i = function() {
          a < 0.1 ? (cancelAnimationFrame($e.value), O.value.push(l), z.value = z.value.map((g, p) => l === p ? {
            ...g,
            value: 0
          } : g), G.value = !1) : (G.value = !0, a /= 1.1, z.value = z.value.map((g, p) => l === p ? {
            ...g,
            value: a
          } : g), $e.value = requestAnimationFrame(i));
        };
        i();
      }
      ve("selectLegend", D.value.map((i) => ({
        name: i.name,
        color: i.color,
        value: i.value
      })));
    }
    const D = k(() => (z.value.forEach((l, r) => {
      if ([null, void 0].includes(l.values))
        return {
          ...l,
          values: []
        };
    }), z.value.map((l, r) => ({
      ...l,
      seriesIndex: r
    })).filter((l, r) => !O.value.includes(r)))), Se = k(() => N.dataset.map((l, r) => ({
      name: l.name,
      color: Be(l.color) || xe.value[r] || V[r] || V[r % V.length],
      value: (l.values || []).reduce((t, a) => t + a, 0),
      shape: "circle"
    })).map((l, r) => ({
      ...l,
      proportion: l.value / N.dataset.map((t) => (t.values || []).reduce((a, i) => a + i, 0)).reduce((t, a) => t + a, 0),
      opacity: O.value.includes(r) ? 0.5 : 1,
      segregate: () => Pe(r),
      isSegregated: O.value.includes(r)
    }))), Re = k(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), C = k(() => {
      const l = Math.min(u.value.width / 3, u.value.height / 3);
      return l < 55 ? 55 : l;
    }), f = k(() => nt({ series: D.value }, u.value.width / 2, u.value.height / 2, C.value, C.value, 1.99999, 2, 1, 360, 105.25, W.value)), c = k(() => {
      const l = Math.max(...D.value.map((t) => t.value)), r = D.value.map((t) => t.value / l);
      return rt({
        series: r,
        center: {
          x: u.value.width / 2,
          y: u.value.height / 2
        },
        maxRadius: Math.min(u.value.width, u.value.height) / 3
      });
    });
    function j(l) {
      return l.x > u.value.width / 2 + 6 ? "start" : l.x < u.value.width / 2 - 6 ? "end" : "middle";
    }
    function Ue(l) {
      return l.middlePoint.y > u.value.height / 2 ? F({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 100, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y : F({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 0, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y - 100;
    }
    function T(l) {
      return l.proportion * 100 > e.value.style.chart.layout.labels.dataLabels.hideUnderValue;
    }
    function se(l, r) {
      const t = l.value / Ee(r);
      return isNaN(t) ? 0 : X(
        e.value.style.chart.layout.labels.percentage.formatter,
        t * 100,
        L({
          v: t * 100,
          s: "%",
          r: e.value.style.chart.layout.labels.percentage.rounding
        }),
        { datapoint: l }
      );
    }
    function Ee(l) {
      return [...l].map((r) => r.value).reduce((r, t) => r + t, 0);
    }
    const $ = k(() => D.value.map((l) => l.value).reduce((l, r) => l + r, 0)), Le = k(() => $.value / D.value.length), ne = d(null), q = d(!1);
    function Fe({ datapoint: l, relativeIndex: r, seriesIndex: t, show: a = !1 }) {
      ne.value = { datapoint: l, seriesIndex: t, config: e.value, series: M.value }, ae.value = a, P.value = r;
      let i = "";
      const g = e.value.style.chart.tooltip.customFormat;
      if (q.value = !1, yt(g))
        try {
          const p = g({
            seriesIndex: t,
            datapoint: l,
            series: M.value,
            config: e.value
          });
          typeof p == "string" && (ue.value = p, q.value = !0);
        } catch {
          console.warn("Custom format cannot be applied."), q.value = !1;
        }
      if (!q.value) {
        if (i += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${l.name}</div>`, i += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${l.color}"/></svg>`, e.value.style.chart.tooltip.showValue && (i += `<b>${X(
          e.value.style.chart.layout.labels.value.formatter,
          l.value,
          L({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: l.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          {
            datapoint: l,
            relativeIndex: r,
            seriesIndex: t
          }
        )}</b>`), e.value.style.chart.tooltip.showPercentage) {
          const p = X(
            e.value.style.chart.layout.labels.percentage.formatter,
            l.proportion * 100,
            L({
              v: l.proportion * 100,
              s: "%",
              r: e.value.style.chart.tooltip.roundingPercentage
            }),
            {
              datapoint: l,
              relativeIndex: r,
              seriesIndex: t
            }
          );
          e.value.style.chart.tooltip.showValue ? i += `<span>(${p})</span></div>` : i += `<b>${p}</b></div>`;
        }
        e.value.style.chart.comments.showInTooltip && l.comment && (i += `<div class="vue-data-ui-tooltip-comment" style="background:${l.color}20; padding: 6px; margin-bottom: 6px; margin-top:6px; border-left: 1px solid ${l.color}">${l.comment}</div>`), ue.value = `<div>${i}</div>`;
      }
    }
    function J(l) {
      return e.value.useBlurOnHover && ![null, void 0].includes(P.value) && P.value !== l ? `url(#blur_${w.value})` : "";
    }
    const A = k(() => {
      const l = D.value.map((t) => ({
        name: t.name,
        color: t.color
      })), r = D.value.map((t) => t.value);
      return { head: l, body: r };
    });
    function ze() {
      Ze(() => {
        const l = A.value.head.map((a, i) => [[
          a.name
        ], [A.value.body[i]], [isNaN(A.value.body[i] / $.value) ? "-" : A.value.body[i] / $.value * 100]]), r = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(l), t = ft(r);
        pt({ csvContent: t, title: e.value.style.chart.title.text || "vue-ui-donut" });
      });
    }
    const oe = k(() => {
      const l = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        L({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: $.value, s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        "100%"
      ], r = A.value.head.map((i, g) => {
        const p = L({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: A.value.body[g], s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue });
        return [
          {
            color: i.color,
            name: i.name
          },
          p,
          isNaN(A.value.body[g] / $.value) ? "-" : (A.value.body[g] / $.value * 100).toFixed(e.value.table.td.roundingPercentage) + "%"
        ];
      }), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value,
          e.value.table.columnNames.percentage
        ],
        head: l,
        body: r,
        config: t
      };
    }), K = d(!1);
    function We(l) {
      K.value = l, ge.value += 1;
    }
    const Te = k(() => /^((?!chrome|android).)*safari/i.test(navigator.userAgent));
    function qe(l) {
      return l.toFixed(e.value.style.chart.legend.roundingPercentage).split("").map((r) => "-").join("");
    }
    function B(l, r) {
      ve("selectDatapoint", { datapoint: l, index: r });
    }
    function Ye() {
      y.value.showTable = !y.value.showTable;
    }
    function Xe() {
      y.value.dataLabels.show = !y.value.dataLabels.show;
    }
    function Ne() {
      y.value.showTooltip = !y.value.showTooltip;
    }
    return Ge({
      getData: He,
      generatePdf: ke,
      generateCsv: ze,
      generateImage: _e,
      toggleTable: Ye,
      toggleLabels: Xe,
      toggleTooltip: Ne
    }), (l, r) => (o(), n("div", {
      ref_key: "donutChart",
      ref: E,
      class: ie(`vue-ui-donut ${K.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: Y(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height:100%;" : ""} text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`),
      id: `donut__${w.value}`
    }, [
      _(l.$slots, "userConfig", {}, void 0, !0),
      e.value.style.chart.title.text ? (o(), n("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: ce,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (o(), H(mt, {
          key: `title_${he.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : v("", !0),
      e.value.userOptions.show && U.value ? (o(), H(kt, {
        ref_key: "details",
        ref: je,
        key: `user_option_${ge.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: s(me),
        isImaging: s(we),
        uid: w.value,
        hasTooltip: e.value.style.chart.tooltip.show && e.value.userOptions.buttons.tooltip,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: K.value,
        chartElement: E.value,
        position: e.value.userOptions.position,
        isTooltip: y.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        onToggleFullscreen: We,
        onGeneratePdf: s(ke),
        onGenerateCsv: ze,
        onGenerateImage: s(_e),
        onToggleTable: Ye,
        onToggleLabels: Xe,
        onToggleTooltip: Ne
      }, Qe({ _: 2 }, [
        l.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: S(() => [
            _(l.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: S(() => [
            _(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: S(() => [
            _(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: S(() => [
            _(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: S(() => [
            _(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionLabels ? {
          name: "optionLabels",
          fn: S(() => [
            _(l.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: S(({ toggleFullscreen: t, isFullscreen: a }) => [
            _(l.$slots, "optionFullscreen", Q(Z({ toggleFullscreen: t, isFullscreen: a })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "onGeneratePdf", "onGenerateImage"])) : v("", !0),
      U.value ? (o(), n("svg", {
        key: 2,
        xmlns: s(it),
        class: ie({ "vue-data-ui-fullscreen--on": K.value, "vue-data-ui-fulscreen--off": !K.value }),
        viewBox: `0 0 ${u.value.width <= 0 ? 10 : u.value.width} ${u.value.height <= 0 ? 10 : u.value.height}`,
        style: Y(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        Ie(St),
        e.value.type === "classic" ? (o(), n("defs", Yt, [
          e.value.style.chart.useGradient ? (o(), n("radialGradient", {
            key: 0,
            id: `gradient_${w.value}`
          }, [
            h("stop", {
              offset: "0%",
              "stop-color": s(ee)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, Nt),
            h("stop", {
              offset: `${(1 - W.value / C.value) * 100}%`,
              "stop-color": s(ee)("#FFFFFF", 0),
              "stop-opacity": "0"
            }, null, 8, Ot),
            h("stop", {
              offset: `${(1 - W.value / C.value / 2) * 100}%`,
              "stop-color": s(ee)("#FFFFFF", e.value.style.chart.gradientIntensity)
            }, null, 8, It),
            h("stop", {
              offset: "100%",
              "stop-color": s(ee)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, Dt)
          ], 8, Xt)) : v("", !0)
        ])) : v("", !0),
        e.value.type === "polar" ? (o(), n("defs", At, [
          (o(!0), n(m, null, I(c.value, (t, a) => (o(), n("radialGradient", {
            id: `polar_gradient_${a}_${w.value}`,
            cx: t.middlePoint.x / u.value.width * 100 + "%",
            cy: t.middlePoint.y / u.value.height * 100 + "%",
            r: "62%"
          }, [
            h("stop", {
              offset: "0%",
              "stop-color": s(vt)(f.value[a].color, 0.05),
              "stop-opacity": e.value.style.chart.gradientIntensity / 100
            }, null, 8, Mt),
            h("stop", {
              offset: "100%",
              "stop-color": f.value[a].color
            }, null, 8, Gt)
          ], 8, Bt))), 256))
        ])) : v("", !0),
        h("defs", null, [
          h("filter", {
            id: `blur_${w.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            h("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${w.value}`
            }, null, 8, jt),
            Ht
          ], 8, Vt),
          h("filter", {
            id: `shadow_${w.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            h("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, Ut)
          ], 8, Rt),
          h("filter", {
            id: `drop_shadow_${w.value}`,
            "color-interpolation-filters": "sRGB",
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            h("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "3",
              "flood-opacity": "1",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, Wt)
          ], 8, Et)
        ]),
        e.value.type === "classic" ? (o(!0), n(m, { key: 2 }, I(f.value, (t, a) => (o(), n("g", null, [
          T(t) && y.value.dataLabels.show ? (o(), n("path", {
            key: 0,
            d: s(ct)(t, { x: u.value.width / 2, y: u.value.height / 2 }, 16, 16, !1, !1, W.value),
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: J(a)
          }, null, 8, qt)) : v("", !0)
        ]))), 256)) : v("", !0),
        e.value.type === "polar" ? (o(!0), n(m, { key: 3 }, I(f.value, (t, a) => (o(), n("g", null, [
          T(t) && y.value.dataLabels.show ? (o(), n("line", {
            key: 0,
            x1: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
            y1: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y,
            x2: c.value[a].middlePoint.x,
            y2: c.value[a].middlePoint.y,
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: J(a)
          }, null, 8, Jt)) : v("", !0)
        ]))), 256)) : v("", !0),
        e.value.type === "classic" ? (o(), n("circle", {
          key: 4,
          cx: u.value.width / 2,
          cy: u.value.height / 2,
          r: C.value <= 0 ? 10 : C.value,
          fill: e.value.style.chart.backgroundColor,
          filter: e.value.style.chart.layout.donut.useShadow ? `url(#shadow_${w.value})` : ""
        }, null, 8, Kt)) : v("", !0),
        $.value && e.value.type === "classic" ? (o(), n(m, { key: 5 }, [
          (o(!0), n(m, null, I(f.value, (t, a) => (o(), n("path", {
            stroke: e.value.style.chart.backgroundColor,
            d: t.arcSlice,
            fill: "#FFFFFF"
          }, null, 8, Qt))), 256)),
          (o(!0), n(m, null, I(f.value, (t, a) => (o(), n("path", {
            class: "vue-ui-donut-arc-path",
            d: t.arcSlice,
            fill: s(ee)(t.color, 80),
            stroke: e.value.style.chart.backgroundColor,
            "stroke-width": e.value.style.chart.layout.donut.borderWidth,
            filter: J(a)
          }, null, 8, Zt))), 256))
        ], 64)) : v("", !0),
        $.value && e.value.type === "polar" ? (o(), n(m, { key: 6 }, [
          f.value.length > 1 ? (o(), n("g", el, [
            (o(!0), n(m, null, I(f.value, (t, a) => (o(), n("path", {
              stroke: e.value.style.chart.backgroundColor,
              d: c.value[a].path,
              fill: "#FFFFFF"
            }, null, 8, tl))), 256)),
            e.value.style.chart.layout.donut.useShadow ? (o(), n("g", ll, [
              (o(!0), n(m, null, I(f.value, (t, a) => (o(), n("path", {
                class: "vue-ui-donut-arc-path",
                d: c.value[a].path,
                fill: "transparent",
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": e.value.style.chart.layout.donut.borderWidth,
                filter: `url(#drop_shadow_${w.value})`
              }, null, 8, al))), 256))
            ])) : v("", !0),
            (o(!0), n(m, null, I(f.value, (t, a) => (o(), n("path", {
              class: "vue-ui-donut-arc-path",
              d: c.value[a].path,
              fill: e.value.style.chart.useGradient ? `url(#polar_gradient_${a}_${w.value})` : t.color,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth,
              filter: J(a)
            }, null, 8, ol))), 256))
          ])) : (o(), n("g", ul, [
            h("circle", {
              cx: u.value.width / 2,
              cy: u.value.height / 2,
              r: C.value,
              fill: e.value.style.chart.useGradient ? `url(#polar_gradient_0_${w.value})` : f.value[0].color,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth
            }, null, 8, sl)
          ]))
        ], 64)) : (o(), n("circle", {
          key: 7,
          cx: u.value.width / 2,
          cy: u.value.height / 2,
          r: C.value <= 0 ? 10 : C.value,
          fill: "transparent",
          stroke: e.value.style.chart.backgroundColor
        }, null, 8, nl)),
        e.value.style.chart.useGradient && e.value.type === "classic" ? (o(), n("circle", {
          key: 8,
          cx: u.value.width / 2,
          cy: u.value.height / 2,
          r: (
            /* This might require adjustments */
            C.value <= 0 ? 10 : C.value
          ),
          fill: `url(#gradient_${w.value})`
        }, null, 8, rl)) : v("", !0),
        $.value ? (o(), n(m, { key: 9 }, [
          f.value.length > 1 || e.value.type === "classic" ? (o(), n("g", il, [
            (o(!0), n(m, null, I(f.value, (t, a) => (o(), n("path", {
              "data-cy-donut-trap": "",
              d: e.value.type === "classic" ? t.arcSlice : c.value[a].path,
              fill: P.value === a ? "rgba(0,0,0,0.1)" : "transparent",
              onMouseenter: (i) => Fe({
                datapoint: t,
                relativeIndex: a,
                seriesIndex: t.seriesIndex,
                show: !0
              }),
              onMouseleave: r[0] || (r[0] = (i) => {
                ae.value = !1, P.value = null;
              }),
              onClick: (i) => B(t, a)
            }, null, 40, vl))), 256))
          ])) : (o(), n("g", cl, [
            h("circle", {
              cx: u.value.width / 2,
              cy: u.value.height / 2,
              r: C.value,
              fill: P.value === l.i ? "rgba(0,0,0,0.1)" : "transparent",
              "data-cy-donut-trap": "",
              onMouseenter: r[1] || (r[1] = (t) => Fe({
                datapoint: f.value[0],
                relativeIndex: 0,
                seriesIndex: f.value[0].seriesIndex,
                show: !0
              })),
              onMouseleave: r[2] || (r[2] = (t) => {
                ae.value = !1, P.value = null;
              }),
              onClick: r[3] || (r[3] = (t) => B(f.value[0], l.i))
            }, null, 40, dl)
          ]))
        ], 64)) : v("", !0),
        e.value.type === "classic" ? (o(), n(m, { key: 10 }, [
          e.value.style.chart.layout.labels.hollow.total.show ? (o(), n("text", {
            key: 0,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.total.bold ? "bold" : ""}`)
          }, x(e.value.style.chart.layout.labels.hollow.total.text), 13, hl)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.total.show ? (o(), n("text", {
            key: 1,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 + e.value.style.chart.layout.labels.hollow.total.fontSize - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.value.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.total.value.bold ? "bold" : ""}`)
          }, x(s(X)(
            e.value.style.chart.layout.labels.hollow.total.value.formatter,
            $.value,
            s(L)({
              p: e.value.style.chart.layout.labels.hollow.total.value.prefix,
              v: $.value,
              s: e.value.style.chart.layout.labels.hollow.total.value.suffix
            })
          )), 13, yl)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (o(), n("text", {
            key: 2,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.average.bold ? "bold" : ""}`)
          }, x(e.value.style.chart.layout.labels.hollow.average.text), 13, fl)) : v("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (o(), n("text", {
            key: 3,
            "text-anchor": "middle",
            x: u.value.width / 2,
            y: u.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.fontSize + e.value.style.chart.layout.labels.hollow.average.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.value.fontSize,
            style: Y(`font-weight:${e.value.style.chart.layout.labels.hollow.average.value.bold ? "bold" : ""}`)
          }, x(G.value ? "--" : s(X)(
            e.value.style.chart.layout.labels.hollow.average.value.formatter,
            Le.value,
            s(L)({
              p: e.value.style.chart.layout.labels.hollow.average.value.prefix,
              v: Le.value,
              s: e.value.style.chart.layout.labels.hollow.average.value.suffix,
              r: e.value.style.chart.layout.labels.hollow.average.value.rounding
            })
          )), 13, pl)) : v("", !0)
        ], 64)) : v("", !0),
        (o(!0), n(m, null, I(f.value, (t, a) => (o(), n("g", {
          filter: J(a),
          class: ie({ animated: e.value.useCssAnimation })
        }, [
          e.value.style.chart.layout.labels.dataLabels.useLabelSlots ? (o(), n("g", bl, [
            (o(), n("foreignObject", {
              x: s(b)(t, !0).anchor === "end" ? s(b)(t).x - 120 : s(b)(t, !0).anchor === "middle" ? s(b)(t).x - 60 : s(b)(t).x,
              y: s(te)(t) - (Te.value ? 20 : 0),
              width: "120",
              height: "60",
              style: { overflow: "visible" }
            }, [
              h("div", null, [
                _(l.$slots, "dataLabel", Q(Z({
                  datapoint: t,
                  isBlur: !e.value.useBlurOnHover || [null, void 0].includes(P.value) || P.value === a,
                  isSafari: Te.value,
                  isVisible: T(t) && y.value.dataLabels.show,
                  textAlign: s(b)(t, !0, 16, !0).anchor,
                  flexAlign: s(b)(t, !0, 16).anchor,
                  percentage: se(t, f.value)
                })), void 0, !0)
              ])
            ], 8, ml))
          ])) : (o(), n("g", wl, [
            e.value.type === "classic" ? (o(), n(m, { key: 0 }, [
              T(t) && y.value.dataLabels.show ? (o(), n("circle", {
                key: 0,
                cx: s(b)(t).x,
                cy: s(te)(t) - 3.5,
                fill: t.color,
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": 1,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(P.value) || P.value === a ? "" : `url(#blur_${w.value})`,
                onClick: (i) => B(t, a)
              }, null, 8, kl)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "polar" ? (o(), n(m, { key: 1 }, [
              T(t) && y.value.dataLabels.show ? (o(), n("circle", {
                key: 0,
                cx: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
                cy: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y,
                fill: t.color,
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": 1,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(P.value) || P.value === a ? "" : `url(#blur_${w.value})`,
                onClick: (i) => B(t, a)
              }, null, 8, _l)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "classic" ? (o(), n(m, { key: 2 }, [
              T(t) && y.value.dataLabels.show ? (o(), n("text", {
                key: 0,
                "text-anchor": s(b)(t, !0, 12).anchor,
                x: s(b)(t, !0, 12).x,
                y: s(te)(t),
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, x(se(t, f.value)) + " " + x(e.value.style.chart.layout.labels.value.show ? `(${s(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                s(L)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, xl)) : v("", !0),
              T(t) && y.value.dataLabels.show ? (o(), n("text", {
                key: 1,
                "text-anchor": s(b)(t).anchor,
                x: s(b)(t, !0, 12).x,
                y: s(te)(t) + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, x(t.name), 13, Cl)) : v("", !0)
            ], 64)) : v("", !0),
            e.value.type === "polar" ? (o(), n(m, { key: 3 }, [
              T(t) && y.value.dataLabels.show ? (o(), n("text", {
                key: 0,
                "text-anchor": j(c.value[a].middlePoint),
                x: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
                y: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y,
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, x(se(t, f.value)) + " " + x(e.value.style.chart.layout.labels.value.show ? `(${s(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                s(L)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, $l)) : v("", !0),
              T(t) && y.value.dataLabels.show ? (o(), n("text", {
                key: 1,
                "text-anchor": j(c.value[a].middlePoint),
                x: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x,
                y: s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).y + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: Y(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (i) => B(t, a)
              }, x(t.name), 13, Pl)) : v("", !0)
            ], 64)) : v("", !0)
          ])),
          y.value.dataLabels.show && e.value.style.chart.comments.show && t.comment ? (o(), n("g", Sl, [
            T(t) && e.value.type === "classic" ? (o(), n("foreignObject", {
              key: 0,
              x: e.value.style.chart.comments.offsetX + (s(b)(t, !0).anchor === "end" ? s(b)(t).x - e.value.style.chart.comments.width : s(b)(t, !0).anchor === "middle" ? s(b)(t).x - e.value.style.chart.comments.width / 2 : s(b)(t).x),
              y: s(te)(t) + 24 + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              h("div", null, [
                _(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: s(b)(t, !0, 16, !0).anchor, flexAlign: s(b)(t, !0, 16).anchor }
                }, void 0, !0)
              ])
            ], 8, Ll)) : v("", !0),
            T(t) && e.value.type === "polar" ? (o(), n("foreignObject", {
              key: 1,
              x: e.value.style.chart.comments.offsetX + (j(c.value[a].middlePoint) === "end" ? s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x - e.value.style.chart.comments.width : j(c.value[a].middlePoint) === "middle" ? s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x - e.value.style.chart.comments.width / 2 : s(F)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: u.value.width / 2, centerY: u.value.height / 2 }).x),
              y: Ue(c.value[a]) + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              h("div", null, [
                _(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: j(c.value[a].middlePoint), flexAlign: j(c.value[a].middlePoint) }
                }, void 0, !0)
              ])
            ], 8, Fl)) : v("", !0)
          ])) : v("", !0)
        ], 10, gl))), 256)),
        _(l.$slots, "svg", { svg: u.value }, void 0, !0)
      ], 14, Tt)) : v("", !0),
      l.$slots.watermark ? (o(), n("div", zl, [
        _(l.$slots, "watermark", Q(Z({ isPrinting: s(me) || s(we) })), void 0, !0)
      ])) : v("", !0),
      U.value ? v("", !0) : (o(), H($t, {
        key: 4,
        config: {
          type: "donut",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donut: {
              color: "#CCCCCC",
              strokeWidth: W.value * 0.8
            }
          }
        }
      }, null, 8, ["config"])),
      h("div", {
        ref_key: "chartLegend",
        ref: de
      }, [
        e.value.style.chart.legend.show ? (o(), H(Ct, {
          key: `legend_${fe.value}`,
          legendSet: Se.value,
          config: Re.value,
          onClickMarker: r[4] || (r[4] = ({ i: t }) => Pe(t))
        }, {
          item: S(({ legend: t, index: a }) => [
            h("div", {
              onClick: (i) => t.segregate(),
              style: Y(`opacity:${O.value.includes(a) ? 0.5 : 1}`)
            }, [
              De(x(t.name) + ": " + x(s(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                s(L)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                {
                  datapoint: t,
                  index: a
                }
              )) + " ", 1),
              O.value.includes(a) ? (o(), n("span", Xl, " ( " + x(qe(t.proportion * 100)) + " % ) ", 1)) : (o(), n("span", Yl, " (" + x(isNaN(t.value / $.value) ? "-" : s(X)(
                e.value.style.chart.layout.labels.percentage.formatter,
                G.value ? t.proportion * 100 : t.value / $.value * 100,
                s(L)({
                  v: G.value ? t.proportion * 100 : t.value / $.value * 100,
                  s: "%",
                  r: e.value.style.chart.legend.roundingPercentage
                })
              )) + ") ", 1))
            ], 12, Tl)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : v("", !0),
        _(l.$slots, "legend", { legend: Se.value }, void 0, !0)
      ], 512),
      Ie(xt, {
        show: y.value.showTooltip && ae.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: E.value,
        content: ue.value,
        isCustom: q.value
      }, {
        "tooltip-before": S(() => [
          _(l.$slots, "tooltip-before", Q(Z({ ...ne.value })), void 0, !0)
        ]),
        "tooltip-after": S(() => [
          _(l.$slots, "tooltip-after", Q(Z({ ...ne.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      U.value ? (o(), H(Pt, {
        key: 5,
        hideDetails: "",
        config: {
          open: y.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: S(() => [
          (o(), H(_t, {
            key: `table_${ye.value}`,
            colNames: oe.value.colNames,
            head: oe.value.head,
            body: oe.value.body,
            config: oe.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: r[5] || (r[5] = (t) => y.value.showTable = !1)
          }, {
            th: S(({ th: t }) => [
              h("div", {
                innerHTML: t,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Nl)
            ]),
            td: S(({ td: t }) => [
              De(x(t.name ? t.name : isNaN(Number(t)) ? t.includes("%") ? t : s(X)(
                e.value.style.chart.layout.labels.percentage.formatter,
                t,
                s(L)({
                  v: t,
                  s: "%",
                  r: e.value.style.chart.layout.labels.percentage.rounding
                })
              ) : s(X)(
                e.value.style.chart.layout.labels.value.formatter,
                t,
                s(L)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                })
              )), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : v("", !0)
    ], 14, zt));
  }
}, ql = /* @__PURE__ */ Lt(Ol, [["__scopeId", "data-v-159f668e"]]);
export {
  ql as default
};
