import { ref as d, computed as g, onMounted as ue, watch as R, onBeforeUnmount as ne, openBlock as r, createElementBlock as u, normalizeClass as D, normalizeStyle as G, createBlock as F, createCommentVNode as c, unref as h, createSlots as ie, withCtx as w, renderSlot as m, normalizeProps as j, guardReactiveProps as V, createVNode as ce, Fragment as I, renderList as P, createElementVNode as b, toDisplayString as x } from "vue";
import { u as he, o as ve, e as q, g as de, c as ge, l as fe, C as me, d as ye, i as _, f as L, X as pe, t as be } from "./index-DDXisDKy.js";
import { u as X } from "./useNestedProp-S1UXxUgm.js";
import { _ as ke } from "./Title-DYNLqCCT.js";
import { L as we } from "./Legend-DXLiSLHd.js";
import { u as xe, U as _e } from "./usePrinter-8ofTb2MJ.js";
import { _ as Le } from "./PackageVersion-DtnhR89q.js";
import { _ as Ce } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const $e = ["id"], Be = ["xmlns", "viewBox"], Fe = { key: 0 }, Ie = ["x", "y", "height", "width", "fill", "stroke"], Pe = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], Se = ["x", "y", "height", "width", "fill", "stroke", "stroke-width"], He = ["x", "y", "font-size", "font-weight", "fill"], ze = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], Me = { key: 3 }, Ne = ["x", "y", "fill", "font-size", "font-weight"], Oe = { key: 4 }, Ae = ["x1", "x2", "y1", "y2", "stroke"], Te = {
  key: 3,
  class: "vue-data-ui-watermark"
}, Ue = {
  class: "vue-ui-bullet-legend-item",
  dir: "auto"
}, We = { style: { "margin-right": "2px" } }, Ee = {
  __name: "vue-ui-bullet",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(Y, { expose: J }) {
    const o = Y, { vue_ui_bullet: K } = he(), S = d(null), Q = d(null), H = d(0), Z = d(null), ee = d(0), C = g({
      get: () => !0,
      set: (t) => t
    }), y = g(() => o.dataset.segments ? Array.isArray(o.dataset.segments) ? o.dataset.segments.length ? !0 : (console.warn(`VueUiBullet: dataset segments is empty. Provide segments with this datastructure:

segments: [
    {
        name: string;
        from: number;
        to: number;
        color?: string;
    },
    {...}
]
        `), !1) : (console.warn(`VueUiBullet: dataset segments must be an array of objects with this datastructure:

segments: [
    {
        name: string;
        from: number;
        to: number;
        color?: string;
    },
    {...}
] 
        `), !1) : !1);
    ue(z);
    function z() {
      ve(o.dataset) ? q({
        componentName: "VueUiBullet",
        type: "dataset"
      }) : y.value && o.dataset.segments.forEach((t, s) => {
        de({
          datasetObject: t,
          requiredAttributes: ["name", "from", "to"]
        }).forEach((l) => {
          C.value = !1, q({
            componentName: "VueUiBullet segment",
            type: "datasetSerieAttribute",
            property: l,
            index: s
          });
        });
      }), e.value.style.chart.animation.show && O(o.dataset.value || 0);
    }
    const $ = d(ge());
    function M() {
      const t = X({
        userConfig: o.config,
        defaultConfig: K
      });
      return t.theme ? {
        ...X({
          userConfig: be.vue_ui_bullet[t.theme] || o.config,
          defaultConfig: t
        })
      } : t;
    }
    const e = g({
      get: () => M(),
      set: (t) => t
    });
    R(() => o.config, (t) => {
      e.value = M(), z(), H.value += 1;
    }, { deep: !0 });
    const a = g(() => {
      const t = e.value.style.chart.height, s = e.value.style.chart.width, l = e.value.style.chart.padding.left, f = s - e.value.style.chart.padding.right, k = e.value.style.chart.padding.top, i = t - e.value.style.chart.padding.bottom;
      return {
        height: t,
        width: s,
        left: l,
        right: f,
        top: k,
        bottom: i,
        chartWidth: f - l,
        chartHeight: i - k
      };
    }), te = g(() => {
      if (!y.value) return [];
      const t = [];
      for (let s = 0; s < o.dataset.segments.length; s += 1)
        t.push(fe(e.value.style.chart.segments.baseColor, s / o.dataset.segments.length));
      return t;
    }), B = g(() => y.value ? {
      min: Math.min(...o.dataset.segments.map((t) => t.from)),
      max: Math.max(...o.dataset.segments.map((t) => t.to))
    } : { min: 0, max: 1 }), n = d(ae());
    R(() => o.dataset, (t) => {
      e.value.style.chart.animation.show ? O(t.value || 0) : n.value = t.value || 0;
    }, { deep: !0 });
    function ae() {
      return e.value.style.chart.animation.show ? B.value.min : o.dataset.value || 0;
    }
    const N = d(null);
    function O(t) {
      const s = Math.abs(t - n.value) / e.value.style.chart.animation.animationFrames;
      function l() {
        n.value < t ? n.value = Math.min(n.value + s, t) : n.value > t && (n.value = Math.max(n.value - s, t)), n.value !== t && (N.value = requestAnimationFrame(l));
      }
      l();
    }
    ne(() => {
      cancelAnimationFrame(N.value);
    });
    const v = g(() => {
      if (!y.value)
        return [];
      const t = me(B.value.min, B.value.max, e.value.style.chart.segments.ticks.divisions), s = t.min >= 0 ? 0 : Math.abs(t.min), l = {
        x: a.value.left + (o.dataset.target + s) / (t.max + s) * a.value.chartWidth - e.value.style.chart.target.width / 2
      }, f = {
        width: (n.value + s) / (t.max + s) * a.value.chartWidth
      }, k = t.ticks.map((i) => ({
        value: i,
        y: a.value.bottom + e.value.style.chart.segments.dataLabels.fontSize + 3 + e.value.style.chart.segments.dataLabels.offsetY,
        x: a.value.left + (i + s) / (t.max + s) * a.value.chartWidth
      }));
      return {
        scale: t,
        target: l,
        value: f,
        ticks: k,
        chunks: o.dataset.segments.map((i, oe) => ({
          ...i,
          color: i.color ? ye(i.color) : te.value[oe],
          x: a.value.left + a.value.chartWidth * ((i.from + s) / (t.max + s)),
          y: a.value.top,
          height: a.value.chartHeight,
          width: a.value.chartWidth * (Math.abs(i.to - i.from) / (t.max + s))
        }))
      };
    }), A = g(() => v.value.chunks.map((t) => {
      const s = _(
        e.value.style.chart.segments.dataLabels.formatter,
        t.from,
        L({
          p: e.value.style.chart.segments.dataLabels.prefix,
          v: t.from,
          s: e.value.style.chart.segments.dataLabels.suffix,
          r: e.value.style.chart.segments.dataLabels.rounding
        })
      ), l = _(
        e.value.style.chart.segments.dataLabels.formatter,
        t.to,
        L({
          p: e.value.style.chart.segments.dataLabels.prefix,
          v: t.to,
          s: e.value.style.chart.segments.dataLabels.suffix,
          r: e.value.style.chart.segments.dataLabels.rounding
        })
      );
      return {
        ...t,
        shape: "square",
        value: `${s} - ${l}`
      };
    })), le = g(() => ({
      cy: "bullet-div-legend",
      backgroundColor: "transparent",
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 6,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), { isPrinting: T, isImaging: U, generatePdf: W, generateImage: E } = xe({
      elementId: `bullet_${$.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-bullet"
    }), p = d(!1);
    function se(t) {
      p.value = t, ee.value += 1;
    }
    function re() {
      return v.value;
    }
    return J({
      generatePdf: W,
      generateImage: E,
      getData: re
    }), (t, s) => (r(), u("div", {
      ref_key: "bulletChart",
      ref: S,
      class: D(`vue-ui-bullet ${p.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: G(`font-family:${e.value.style.fontFamily};width:100%;background:${e.value.style.chart.backgroundColor}`),
      id: `bullet_${$.value}`
    }, [
      e.value.style.chart.title.text ? (r(), u("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: Q,
        style: "width:100%;background:transparent;"
      }, [
        (r(), F(ke, {
          lineHeight: "1.3rem",
          key: `title_${H.value}`,
          config: {
            title: {
              cy: "bullet-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "bullet-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : c("", !0),
      e.value.userOptions.show && C.value ? (r(), F(_e, {
        key: 1,
        ref: "details",
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: h(T),
        isImaging: h(U),
        uid: $.value,
        hasTooltip: !1,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: !1,
        hasTable: !1,
        hasLabel: !1,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: p.value,
        chartElement: S.value,
        position: e.value.userOptions.position,
        titles: { ...e.value.userOptions.buttonTitles },
        onToggleFullscreen: se,
        onGeneratePdf: h(W),
        onGenerateImage: h(E)
      }, ie({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: w(() => [
            m(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: w(() => [
            m(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: w(({ toggleFullscreen: l, isFullscreen: f }) => [
            m(t.$slots, "optionFullscreen", j(V({ toggleFullscreen: l, isFullscreen: f })), void 0, !0)
          ]),
          key: "2"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "chartElement", "position", "titles", "onGeneratePdf", "onGenerateImage"])) : c("", !0),
      C.value ? (r(), u("svg", {
        key: 2,
        xmlns: h(pe),
        class: D({ "vue-data-ui-fullscreen--on": p.value, "vue-data-ui-fulscreen--off": !p.value, "vue-ui-bullet-svg": !0 }),
        viewBox: `0 0 ${a.value.width} ${a.value.height}`,
        style: G(`width: 100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        ce(Le),
        y.value ? (r(), u("g", Fe, [
          (r(!0), u(I, null, P(v.value.chunks, (l) => (r(), u("rect", {
            x: l.x,
            y: l.y,
            height: l.height,
            width: l.width,
            fill: l.color,
            "stroke-width": 1,
            stroke: e.value.style.chart.backgroundColor
          }, null, 8, Ie))), 256)),
          e.value.style.chart.target.onTop ? c("", !0) : (r(), u("rect", {
            key: 0,
            x: v.value.target.x,
            y: a.value.top + (a.value.chartHeight - a.value.chartHeight * e.value.style.chart.target.heightRatio) / 2,
            height: a.value.chartHeight * e.value.style.chart.target.heightRatio,
            width: e.value.style.chart.target.width,
            rx: e.value.style.chart.target.rounded ? e.value.style.chart.target.width / 2 : 0,
            fill: e.value.style.chart.target.color,
            stroke: e.value.style.chart.target.stroke,
            "stroke-width": e.value.style.chart.target.strokeWidth
          }, null, 8, Pe)),
          b("rect", {
            x: a.value.left,
            y: a.value.top + (a.value.chartHeight - a.value.chartHeight * e.value.style.chart.valueBar.heightRatio) / 2,
            height: a.value.chartHeight * e.value.style.chart.valueBar.heightRatio,
            width: v.value.value.width,
            fill: e.value.style.chart.valueBar.color,
            stroke: e.value.style.chart.valueBar.stroke,
            "stroke-width": e.value.style.chart.valueBar.strokeWidth
          }, null, 8, Se),
          e.value.style.chart.valueBar.label.show ? (r(), u("text", {
            key: 1,
            x: a.value.left + v.value.value.width,
            y: a.value.top - 6 + e.value.style.chart.valueBar.label.offsetY,
            "font-size": e.value.style.chart.valueBar.label.fontSize,
            "font-weight": e.value.style.chart.valueBar.label.bold ? "bold" : "normal",
            fill: e.value.style.chart.valueBar.label.color,
            "text-anchor": "middle"
          }, x(h(_)(
            e.value.style.chart.segments.dataLabels.formatter,
            n.value,
            h(L)({
              p: e.value.style.chart.segments.dataLabels.prefix,
              v: n.value,
              s: e.value.style.chart.segments.dataLabels.suffix,
              r: e.value.style.chart.segments.dataLabels.rounding
            })
          )), 9, He)) : c("", !0),
          e.value.style.chart.target.onTop ? (r(), u("rect", {
            key: 2,
            x: v.value.target.x,
            y: a.value.top + (a.value.chartHeight - a.value.chartHeight * e.value.style.chart.target.heightRatio) / 2,
            height: a.value.chartHeight * e.value.style.chart.target.heightRatio,
            width: e.value.style.chart.target.width,
            rx: e.value.style.chart.target.rounded ? e.value.style.chart.target.width / 2 : 0,
            fill: e.value.style.chart.target.color,
            stroke: e.value.style.chart.target.stroke,
            "stroke-width": e.value.style.chart.target.strokeWidth
          }, null, 8, ze)) : c("", !0),
          e.value.style.chart.segments.dataLabels.show ? (r(), u("g", Me, [
            (r(!0), u(I, null, P(v.value.ticks, (l) => (r(), u("text", {
              x: l.x,
              y: l.y,
              "text-anchor": "middle",
              fill: e.value.style.chart.segments.dataLabels.color,
              "font-size": e.value.style.chart.segments.dataLabels.fontSize + "px",
              "font-weight": e.value.style.chart.segments.dataLabels.bold ? "bold" : "normal"
            }, x(h(_)(
              e.value.style.chart.segments.dataLabels.formatter,
              l.value,
              h(L)({
                p: e.value.style.chart.segments.dataLabels.prefix,
                v: l.value,
                s: e.value.style.chart.segments.dataLabels.suffix,
                r: e.value.style.chart.segments.dataLabels.rounding
              })
            )), 9, Ne))), 256))
          ])) : c("", !0),
          e.value.style.chart.segments.dataLabels.show && e.value.style.chart.segments.ticks.show ? (r(), u("g", Oe, [
            (r(!0), u(I, null, P(v.value.ticks, (l) => (r(), u("line", {
              x1: l.x,
              x2: l.x,
              y1: a.value.bottom,
              y2: a.value.bottom + 3,
              stroke: e.value.style.chart.segments.ticks.stroke,
              "stroke-width": 1,
              "stroke-linecap": "round"
            }, null, 8, Ae))), 256))
          ])) : c("", !0)
        ])) : c("", !0),
        m(t.$slots, "svg", { svg: a.value }, void 0, !0)
      ], 14, Be)) : c("", !0),
      t.$slots.watermark ? (r(), u("div", Te, [
        m(t.$slots, "watermark", j(V({ isPrinting: h(T) || h(U) })), void 0, !0)
      ])) : c("", !0),
      b("div", {
        ref_key: "chartLegend",
        ref: Z
      }, [
        e.value.style.chart.legend.show ? (r(), F(we, {
          key: 0,
          clickable: !1,
          legendSet: A.value,
          config: le.value
        }, {
          item: w(({ legend: l }) => [
            b("div", Ue, [
              b("span", We, x(l.name) + ":", 1),
              b("span", null, x(l.value), 1)
            ])
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : c("", !0),
        m(t.$slots, "legend", { legend: A.value }, void 0, !0)
      ], 512)
    ], 14, $e));
  }
}, Je = /* @__PURE__ */ Ce(Ee, [["__scopeId", "data-v-8f9b47b1"]]);
export {
  Je as default
};
